// (C) Copyright 2003: Reece H. Dunn 

#ifndef BOOST__IO__FORMAT_OBJECTS__CONTAINER_OUTPUT__HPP
#define BOOST__IO__FORMAT_OBJECTS__CONTAINER_OUTPUT__HPP
#  include <boost/io/format_objects/detail/list_output.hpp>

   namespace boost { namespace io
   {
      template< typename FormatType, typename Outputter = boost::io::basic_output >
      class container_output: public detail::list_output< FormatType, container_output
                                                                      <
                                                                         FormatType,
                                                                         Outputter
                                                                      >, Outputter >
      {
         public:
            template< typename Container, class OutputStream >
            inline OutputStream & operator()
                                  (
                                     OutputStream &    os,
                                     const Container & c
                                  ) const
            {
               return( detail::list_output< FormatType, container_output, Outputter >::operator()
               (
                  os, c.begin(), c.end()
               ));
            }
         public:
            inline           container_output() throw();
            inline           container_output( const Outputter & ) throw();
            inline           container_output( const container_output & ) throw();
            template< typename RT2 >
            inline           container_output
                             (
                                const formatter_t< FormatType, RT2 > & fmt
                             ) throw():
               detail::list_output< FormatType, container_output, Outputter >( fmt )
            {
            }
      };

      // container_output generators

      container_output< char >                   containerfmt();

      template< typename FormatType >
      container_output< FormatType >             containerfmtex();
   }}

#  include "detail/container_output.ipp"
#endif
