// (C) Copyright 2003: Reece H. Dunn

#ifndef BOOST__IO__FORMAT_OBJECTS__ARRAY_OUTPUT__IPP
#define BOOST__IO__FORMAT_OBJECTS__ARRAY_OUTPUT__IPP
   template< typename FormatType, typename Outputter >
   boost::io::array_output< FormatType, Outputter > &
   boost::io::array_output< FormatType, Outputter >::operator()( long len )
   {
      length = len;
      offset = 0;
      return( *this );
   }
   template< typename FormatType, typename Outputter >
   boost::io::array_output< FormatType, Outputter > &
   boost::io::array_output< FormatType, Outputter >::operator()( long off, long len )
   {
      length = len;
      offset = off;
      return( *this );
   }

   template< typename FormatType, typename Outputter >
   boost::io::array_output< FormatType, Outputter >::array_output( long len ) throw():
      length( len ),
      offset( 0 )
   {
   }
   template< typename FormatType, typename Outputter >
   boost::io::array_output< FormatType, Outputter >::array_output( long off, long len ) throw():
      length( len ),
      offset( off )
   {
   }
   template< typename FormatType, typename Outputter >
   boost::io::array_output< FormatType, Outputter >::array_output( const Outputter & o, long len ) throw():
      detail::list_output< FormatType, array_output, Outputter >( o ),
      length( len ),
      offset( 0 )
   {
   }
   template< typename FormatType, typename Outputter >
   boost::io::array_output< FormatType, Outputter >::array_output( const Outputter & o, long len, long off ) throw():
      detail::list_output< FormatType, array_output, Outputter >( o ),
      length( len ),
      offset( off )
   {
   }
   template< typename FormatType, typename Outputter >
   boost::io::array_output< FormatType, Outputter >::array_output( const array_output & o ) throw():
      detail::list_output< FormatType, array_output, Outputter >( o ),
      length( o.length ),
      offset( o.offset )
   {
   }

   // array_output generators

   boost::io::array_output< char > boost::io::arrayfmt( long l )
   {
      return( boost::io::array_output< char >( l ));
   }
   boost::io::array_output< char > boost::io::arrayfmt( long o, long l )
   {
      return( boost::io::array_output< char >( o, l ));
   }

   template< typename FormatType >
   boost::io::array_output< FormatType > boost::io::arrayfmtex( long l )
   {
      return( array_output< FormatType >( l ));
   }
   template< typename FormatType >
   boost::io::array_output< FormatType > boost::io::arrayfmtex( long o, long l )
   {
      return( array_output< FormatType >( o, l ));
   }

   template< class Outputter >
   boost::io::array_output< typename Outputter::listfmt_type, Outputter > boost::io::arrayfmtout( const Outputter & out, long l )
   {
      return( boost::io::array_output< typename Outputter::listfmt_type, Outputter >( out, l ));
   }
   template< class Outputter >
   boost::io::array_output< typename Outputter::listfmt_type, Outputter > boost::io::arrayfmtout( const Outputter & out, long o, long l )
   {
      return( array_output< typename Outputter::listfmt_type, Outputter >( out, o, l ));
   }
#endif
